MARTe2-core - User story #114

MARTe-EX-D-1.3.1: The framework shall allow developers to protect shared resources using mutex
semaphores.

29.05.2015 14:18 - André Neto

Status: Closed Start date:
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 4.00 hours
Target version: 0.2 Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

Implement requirement MARTe-EX-D-1.3.1 based on the original MARTe implementation

Note: The development of multi-thread real-time applications usually requires the controlled and unique access to shared resources.

Source code files modified

Source/Core/L0Portability/MutexSem.cpp
Source/Core/L0Portability/MutexSem.h
Source/Core/L0Portability/OperatingSystem/Linux/MutexSemOS.h
Source/Core/L0Portability/OperatingSystem/Windows/MutexSemQOS.h
Source/Core/L0Portability/SemCore.h
Test/Core/LOPortability/MutexTest.cpp
Test/Core/LOPortability/MutexTest.h

Test/GTest/MutexGTest.cpp

Architecture & design review
Date of the review: 12/06/2015
Person who did the review: André Neto

Version of architecture & design document: N/A. As per the original MARTe implementation, this is a support function and does
not require formal design in UML.

Result of review: N/A

List of non-conformities: N/A

Code and documentation review
Date of the review: 01/07/2015

Person who did the review: lvan Herrero

Result of review: PASS

List of non-conformities: N/A

Unit test review
Date of the review: 23/07/2015

Person who did the review: Ivan Herrero
Result of coverage tests review: PASS
Result of functional tests review: PASS
Result of review: PASS

List of non-conformities: N/A

Unit testing coverage note: Error paths not exercised

Associated revisions

Revision d10f7c3c - 18.06.2015 10:32 - Giuseppe Ferro

Added MutexSem implementation.
#115 #117 #114

Revision 16238ec2 - 22.06.2015 14:00 - Giuseppe Ferro

Fixed semaphore files accordingly with revision.
#115 #117 #119 #118 #114

Revision cd81fb26 - 22.06.2015 14:02 - Giuseppe Ferro

¢ Fixed semaphore files accordingly with revision.
#115 #1117 #119 #118 #114

Revision 04e5ad39 - 26.06.2015 11:49 - Giuseppe Ferro

Corrected code accrodingly with revision.
Added the possibility to get and set the recursive mutex.
#114

Revision 192c81cf - 26.06.2015 12:01 - Giuseppe Ferro

Added MutexSem unit tests.
Renamed previous tests as integration tests.
#116 #115 #117 #114

Revision b5bf0092 - 26.06.2015 12:07 - Giuseppe Ferro

Added MutexSem integration GTest.
#114

Revision 1fe7f3c8 - 01.07.2015 08:53 - Giuseppe Ferro

Fixed issues on mutex semaphores.
#114

Revision d85e9073 - 01.07.2015 12:19 - Giuseppe Ferro

Put PrivateSem classes inside the main classes.
#114 #118

Revision 84dcd972 - 01.07.2015 18:26 - André Neto
Corrected bug in MutexSemOS::Create() method. #114

The Linux implementation of MutexSemOS::Create() was returning false
even when it was successfully created.

Revision 08bae2b9 - 01.07.2015 18:27 - André Neto

MutexSem unit testing implementation ready for review #114.

Implemented the MutexSem unit testing accordingly to the agreed unit
testing strategy.

Revision ed690475 - 01.07.2015 18:44 - André Neto

Removed the MutexSemlntegration test from the Makefile. #114

Revision bdae23d2 - 01.07.2015 18:46 - André Neto
Removed the MutexIntegrationTest from the Makefile. #114

Revision cae1fc5c - 01.07.2015 18:50 - André Neto
Removed MutexIntegrationGTest. #114

Revision dd952031 - 01.07.2015 23:55 - André Neto

Implementation of coding style. #114

Revision c9bcd107 - 02.07.2015 10:21 - André Neto

Addition of two new unit tests. #114

Two new unit tests were added to the MutexSem: Create and Close. These
consider all the different possibilities of creating a semaphore.

Revision 484e8ad6 - 10.07.2015 13:10 - LIorenc Capella
US #114 MutexSemTests

List of changes: * Improvement of the documentation and format the MutexSemTest.h
MutexSemTest.cpp  * MutexSemGTest.cpp template addes.

Revision 29b8a4d5 - 22.07.2015 08:27 - Giuseppe Ferro

Since linux can support recursive and not recursive mode for mutexes,
the flag recursive must be initialized.
#114

Revision a14f57d7 - 23.07.2015 14:20 - lvan Herrero

#114 - Minor formatting corrections (following template rules)

History

#1 - 03.06.2015 11:11 - Riccardo Vitelli

- Target version changed from Backlog to 0.1
- Start date deleted (29.05.2015)

- Estimated time set to 4.00 h

#2 - 12.06.2015 10:31 - Riccardo Vitelli

- Status changed from New to Arch: Rev

#3 - 12.06.2015 11:15 - Riccardo Vitelli

- Assignee set to André Neto

#4 - 12.06.2015 18:30 - André Neto

- Description updated

#5 - 18.06.2015 09:37 - lvan Herrero
- Status changed from Arch: Rev to Code: Impl

#6 - 18.06.2015 09:47 - lvan Herrero

- Assignee changed from André Neto to Giuseppe Ferro

#7 - 18.06.2015 12:41 - lvan Herrero

- Assignee changed from Giuseppe Ferro to Ivan Herrero

#8 - 18.06.2015 12:42 - lvan Herrero
- Status changed from Code: Impl to Code: Rev

#9 - 18.06.2015 17:30 - lvan Herrero

- Description updated
#10 - 18.06.2015 18:11 - lvan Herrero
- Description updated

- Assignee deleted (lvan Herrero)

#11 - 18.06.2015 18:15 - Ivan Herrero

Code and documentation review failed. Code correction pending.

#12 - 22.06.2015 12:56 - Ivan Herrero
- Status changed from Code: Rev to Code: Impl

#13 - 22.06.2015 17:31 - Riccardo Vitelli

- Assignee set to Giuseppe Ferro

#14 - 22.06.2015 17:33 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#15 - 22.06.2015 17:34 - Riccardo Vitelli

- Assignee changed from Giuseppe Ferro to Ivan Herrero

#16 - 23.06.2015 12:35 - Ilvan Herrero

- Description updated

Code and documentation review failed on revision b99ba9f. Code and documentation corrections pending.

#17 - 23.06.2015 18:06 - André Neto
- Status changed from Code: Rev to Code: Impl

#18 - 23.06.2015 18:06 - André Neto

- Assignee changed from Ivan Herrero to Giuseppe Ferro

#19 - 25.06.2015 17:18 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#20 - 25.06.2015 17:20 - Riccardo Vitelli
- Assignee deleted (Giuseppe Ferro)

#21 - 25.06.2015 19:19 - Ilvan Herrero

- Description updated

Source/Core/LOPortability/OperatingSystem/Linux/MutexSemOS.h not corrected, yet.

#22 - 25.06.2015 19:19 - Ivan Herrero
- Status changed from Code: Rev to Code: Impl

#23 - 26.06.2015 11:44 - Giuseppe Ferro

- Assignee set to Giuseppe Ferro

#24 - 29.06.2015 09:52 - Riccardo Vitelli
- Status changed from Code: Impl to Code: Rev

#25 - 29.06.2015 09:53 - Riccardo Vitelli
- Assignee deleted (Giuseppe Ferro)

#26 - 01.07.2015 11:19 - Ivan Herrero

- Assignee set to Ivan Herrero
#27 - 01.07.2015 12:25 - lvan Herrero

- Description updated

Code and documentation review made on revision 8064124 [PASS].

#28 - 01.07.2015 13:07 - Riccardo Vitelli
- Status changed from Code: Rev to Unit: Impl

#29 - 01.07.2015 13:07 - Riccardo Vitelli

- Assignee deleted (lvan Herrero)

#30 - 01.07.2015 17:50 - André Neto

- Assignee set to André Neto

#31 - 02.07.2015 10:25 - Riccardo Vitelli
- Status changed from Unit: Impl to Unit: Rev
- Assignee deleted (André Neto)

#32 - 02.07.2015 12:37 - Ilvan Herrero
- Description updated

- Assignee set to Ivan Herrero

Unit test review made on revision 7fb5f4b [FAIL].

#33 - 02.07.2015 12:41 - Riccardo Vitelli
- Status changed from Unit: Rev to Unit: Impl

- Assignee deleted (lvan Herrero)

#34 - 02.07.2015 18:06 - Riccardo Vitelli

- Target version changed from 0.1 to 0.2

#35 - 10.07.2015 11:25 - Llorenc Capella

- Assignee set to Llorenc Capella

#36 - 15.07.2015 11:00 - Llorenc Capella
- Status changed from Unit: Impl to Unit: Rev

#37 - 15.07.2015 11:01 - Llorenc Capella
- Assignee deleted (Llorenc Capella)

#38 - 23.07.2015 11:54 - lvan Herrero

- Assignee set to Ivan Herrero

#39 - 23.07.2015 14:26 - Ilvan Herrero
- Description updated
- Status changed from Unit: Rev to Closed

- Assignee deleted (Ilvan Herrero)

Unit test review made on revision a14f57d.
